unit Main; //18.06.2012 by Heizkoerper

{$mode objfpc}{$H+}

interface

uses Classes,SysUtils,Forms,Controls,Graphics,Dialogs,EditBtn,ExtCtrls,StdCtrls;

type

{ TFormCompiler }

 TFormCompiler=class(TForm)
  ButtonStart           :TButton;
  ButtonEnde            :TButton;
  Image                 :TImage;
  LabelDrehwinkelUmX    :TLabel;
  LabelDrehwinkelUmY    :TLabel;
  LabelDrehwinkelUmZ    :TLabel;
  LabelTranslationX     :TLabel;
  LabelGroesse          :TLabel;
  LabelAbstand          :TLabel;
  LabelTranslationY     :TLabel;
  LabelTranslationZ     :TLabel;
  LabelFormelNr         :TLabel;
  LabelYMax             :TLabel;
  LabelXMin             :TLabel;
  LabelFormel           :TLabel;
  LabelXMax             :TLabel;
  LabelNetz             :TLabel;
  LabelYMin             :TLabel;
  RadioGroupArt         :TRadioGroup;
  ScrollBarDrehwinkelUmX:TScrollBar;
  ScrollBarDrehwinkelUmY:TScrollBar;
  ScrollBarDrehwinkelUmZ:TScrollBar;
  ScrollBarTranslationX :TScrollBar;
  ScrollBarGroesse      :TScrollBar;
  ScrollBarAbstand      :TScrollBar;
  ScrollBarTranslationY :TScrollBar;
  ScrollBarTranslationZ :TScrollBar;
  ScrollBarFormel       :TScrollBar;
  ScrollBarYMax         :TScrollBar;
  ScrollBarXMin         :TScrollBar;
  ScrollBarXMax         :TScrollBar;
  ScrollBarNetz         :TScrollBar;
  ScrollBarYMin         :TScrollBar;
  procedure ButtonEndeClick(Sender:TObject);
  procedure ButtonStartClick(Sender:TObject);
  procedure ScrollBarAbstandChange(Sender:TObject);
  procedure ScrollBarDrehwinkelUmXChange(Sender:TObject);
  procedure ScrollBarDrehwinkelUmYChange(Sender:TObject);
  procedure ScrollBarDrehwinkelUmZChange(Sender:TObject);
  procedure ScrollBarGroesseChange(Sender:TObject);
  procedure ScrollBarNetzChange(Sender:TObject);
  procedure ScrollBarTranslationXChange(Sender:TObject);
  procedure ScrollBarTranslationYChange(Sender:TObject);
  procedure ScrollBarTranslationZChange(Sender:TObject);
  procedure ScrollBarFormelChange(Sender:TObject);
  procedure ScrollBarXMaxChange(Sender:TObject);
  procedure ScrollBarXMinChange(Sender:TObject);
  procedure ScrollBarYMaxChange(Sender:TObject);
  procedure ScrollBarYMinChange(Sender:TObject);
 end;

var FormCompiler:TFormCompiler;

implementation

{$R *.lfm}

procedure TFormCompiler.ButtonEndeClick(Sender:TObject);
begin Close end;

procedure TFormCompiler.ButtonStartClick(Sender:TObject);
Const ImageX=500;
Var   x,xAlt,y,yAlt,DeltaX,DeltaY,PunktX,PunktY,PunktZ:Extended;
      UHorizont,OHorizont:Array[-ImageX..ImageX] Of Extended;
 Function f(x,y:Extended):Extended;
  Function Pot(x:Extended;y:Byte):Extended;
  Var i:Byte;
      h:Extended;
  Begin
   h:=1;
   For i:=1 To y Do h:=h*x;
   Pot:=h
  End;
 Begin
  Case ScrollBarFormel.Position Of
   1:f:=1.5/(x*x+y*y+0.25);
   2:f:=10*Pot(Sin(Pi/10*x)*Sin(Pi/5*y),11);
   3:f:=5-5*Pot(Sin(Pi/10*x)*Cos(Pi/10*y),8);
   4:f:=Sin(x*y);
   5:f:=1.5*(x-y)*Cos(x-y)/(x*x+y*y+0.25);
   6:f:=Cos(0.1*(x*x+y*y));
   7:f:=Sin(x-y)/(x*x+0.1);
   8:f:=Sin(x+Cos(y));
   9:f:=Sin(x+Sin(x*y))
  End
 End;
 Procedure Transformieren(x,y,z:Extended;Groesse,TransX,TransY,TransZ:Integer;
                          AlphaUmX,BetaUmY,GammaUmZ:Extended);
 Var xx,yy,zz:Extended;
 Begin
  PunktX:=x*Groesse+TransX;PunktY:=y*Groesse+TransY;PunktZ:=z*Groesse+TransZ;
  If GammaUmZ<>0 Then
   Begin
    xx:=PunktX;yy:=PunktY;
    PunktX:=xx*Cos(GammaUmZ)-yy*Sin(GammaUmZ);
    PunktY:=xx*Sin(GammaUmZ)+yy*Cos(GammaUmZ);
   End;
  If AlphaUmX<>0 Then
   Begin
    yy:=PunktY;zz:=PunktZ;
    PunktY:=yy*Cos(AlphaUmX)-zz*Sin(AlphaUmX);
    PunktZ:=yy*Sin(AlphaUmX)+zz*Cos(AlphaUmX);
   End;
  If BetaUmY<>0 Then
   Begin
    xx:=PunktX;zz:=PunktZ;
    PunktX:=zz*Sin(BetaUmY)+xx*Cos(BetaUmY);
    PunktZ:=zz*Cos(BetaUmY)-xx*Sin(BetaUmY)
   End
 End;
 Procedure Darstellen(Linie:Boolean;Version:Byte;x,y,z:Extended;Abstand:Word;
                      Farbe:TColor;Staerke:Byte);
 Var xx,yy,Steigung:Extended;
 Begin
  If (Abstand+z<>0) And (Abstand<ScrollBarAbstand.Max) Then
   Begin xx:=x*Abstand/(Abstand+z);yy:=-y*Abstand/(Abstand+z) End
                                                       Else
   Begin xx:=x;yy:=-y End;
  With Image.Canvas Do
   Begin
    xx:=xx+Image.Width/2;yy:=yy+Image.Height/2;
    If Linie Then
     Begin
      Pen.Color:=Farbe;Pen.Width:=Staerke;
      Steigung:=(yy-yAlt)/(xx-xAlt);
      If (Version=0) Or (Version=2) Then
       Begin
        MoveTo(Round(xAlt),Round(yAlt));LineTo(Round(xx),Round(yy));
        Pen.Color:=clWhite;Pen.Width:=1
       End;
      x:=xAlt;yy:=yAlt;
      While x<=xx Do
       Begin
        If (x>=-Image.Width) And (x<=Image.Width) Then
         Begin
          y:=(x-xAlt)*Steigung+yAlt;
          Case Version Of
           0:Begin MoveTo(Round(x),Round(y+2));LineTo(Round(x),Image.Height) End;
           1:Begin
              If y>OHorizont[Round(x)] Then OHorizont[Round(x)]:=y;
              If y<UHorizont[Round(x)] Then UHorizont[Round(x)]:=y;
              If (y>=OHorizont[Round(x)]) Or (y<=UHorizont[Round(x)]) Then
               Begin MoveTo(Round(x-1),Round(yy));LineTo(Round(x),Round(y)) End
             End
          End
         End;
        x:=x+1;yy:=y
       End
     End;
    xAlt:=xx;yAlt:=yy
   End
 End;
 Function Rad(x:Extended):Extended;
 Begin Rad:=x*Pi/180 End;
 Procedure GitterZeichnen3D;
  Procedure InnereSchleife;
  Begin
   x:=ScrollBarXMin.Position;
   While x<=ScrollBarXMax.Position Do
    Begin
     Transformieren(x,y,f(x,y),ScrollBarGroesse.Position,ScrollBarTranslationX.Position,
                    ScrollBarTranslationY.Position,ScrollBarTranslationZ.Position,
                    Rad(ScrollBarDrehwinkelUmX.Position),
                    Rad(ScrollBarDrehwinkelUmY.Position),
                    Rad(ScrollBarDrehwinkelUmZ.Position));
     If x<=ScrollBarXMin.Position Then
      Darstellen(False,RadioGroupArt.ItemIndex,PunktX,PunktY,PunktZ,
                 ScrollBarAbstand.Position,clBlack,1)
                                  Else
      Darstellen(True,RadioGroupArt.ItemIndex,PunktX,PunktY,PunktZ,
                 ScrollBarAbstand.Position,clBlack,1);
     x:=x+DeltaX
    End
  End;
 Const Horizont=1e100;
 Var   i:Integer;
 Begin
  If ScrollBarXMax.Position>ScrollBarXMin.Position Then
   Begin
    DeltaX:=(ScrollBarXMax.Position-ScrollBarXMin.Position)/ScrollBarNetz.Position;
    DeltaY:=(ScrollBarYMax.Position-ScrollBarYMin.Position)/ScrollBarNetz.Position;
    Case RadioGroupArt.ItemIndex Of
     0,2:Begin
          y:=ScrollBarYMax.Position;
          While y>=ScrollBarYMin.Position Do
           Begin InnereSchleife;y:=y-DeltaY End
         End;
     1  :Begin
          For i:=-ImageX To ImageX Do
           Begin UHorizont[i]:=Horizont;OHorizont[i]:=-Horizont End;
          y:=ScrollBarYMin.Position;
          While y<=ScrollBarYMax.Position Do
           Begin InnereSchleife;y:=y+DeltaY End
         End
    End
   End
 End;
Var i:Byte;
begin
 With Image.Canvas Do
  Begin
   Pen.Color:=clWhite;Brush.Color:=clWhite;Font.Color:=clBlack;
   For i:=1 To 2 Do Rectangle(0,0,Width,Height);
   Image.Picture.Bitmap.BeginUpdate(True);
   GitterZeichnen3D;
   Image.Picture.Bitmap.EndUpdate()
  End
end;

procedure TFormCompiler.ScrollBarAbstandChange(Sender:TObject);
begin
 LabelAbstand.Caption:='Abstand: '+IntToStr(ScrollBarAbstand.Position);
 ButtonStartClick(Sender)
end;

procedure TFormCompiler.ScrollBarDrehwinkelUmXChange(Sender:TObject);
begin
 LabelDrehwinkelUmX.Caption:='Drehwinkel um X: '+
  IntToStr(ScrollBarDrehwinkelUmX.Position);
 ButtonStartClick(Sender)
end;

procedure TFormCompiler.ScrollBarDrehwinkelUmYChange(Sender:TObject);
begin
 LabelDrehwinkelUmY.Caption:='Drehwinkel um Y: '+
  IntToStr(ScrollBarDrehwinkelUmY.Position);
 ButtonStartClick(Sender)
end;

procedure TFormCompiler.ScrollBarDrehwinkelUmZChange(Sender:TObject);
begin
 LabelDrehwinkelUmZ.Caption:='Drehwinkel um Z: '+
  IntToStr(ScrollBarDrehwinkelUmZ.Position);
 ButtonStartClick(Sender)
end;

procedure TFormCompiler.ScrollBarGroesseChange(Sender:TObject);
begin
 LabelGroesse.Caption:='Größe: '+IntToStr(ScrollBarGroesse.Position);
 ButtonStartClick(Sender)
end;

procedure TFormCompiler.ScrollBarNetzChange(Sender:TObject);
begin
 LabelNetz.Caption:='Netz: '+IntToStr(ScrollBarNetz.Position);
 ButtonStartClick(Sender)
end;

procedure TFormCompiler.ScrollBarTranslationXChange(Sender:TObject);
begin
 LabelTranslationX.Caption:='Translation X: '+
  IntToStr(ScrollBarTranslationX.Position);
 ButtonStartClick(Sender)
end;

procedure TFormCompiler.ScrollBarTranslationYChange(Sender:TObject);
begin
 LabelTranslationY.Caption:='Translation Y: '+
  IntToStr(ScrollBarTranslationY.Position);
 ButtonStartClick(Sender)
end;

procedure TFormCompiler.ScrollBarTranslationZChange(Sender:TObject);
begin
 LabelTranslationZ.Caption:='Translation Z: '+
  IntToStr(ScrollBarTranslationZ.Position);
 ButtonStartClick(Sender)
end;

procedure TFormCompiler.ScrollBarFormelChange(Sender:TObject);
begin
 Case ScrollBarFormel.Position Of
  1:Begin
     LabelFormel.Caption:='z=f(x,y)=1.5/(x*x+y*y+0.25)';
     ScrollBarXMin.Position:=-3;ScrollBarXMax.Position:=3;
     ScrollBarYMin.Position:=-3;ScrollBarYMax.Position:=3;
     ScrollBarGroesse.Position:=60
    End;
  2:Begin
     LabelFormel.Caption:='z=f(x,y)=10*(Sin(Pi/10*x)*Sin(Pi/5*y))^11';
     ScrollBarXMin.Position:=-12;ScrollBarXMax.Position:=12;
     ScrollBarYMin.Position:=-12;ScrollBarYMax.Position:=12;
     ScrollBarGroesse.Position:=15
    End;
  3:Begin
     LabelFormel.Caption:='z=f(x,y)=5-5*(Sin(Pi/10*x)*Cos(Pi/10*y))^8';
     ScrollBarXMin.Position:=-5;ScrollBarXMax.Position:=5;
     ScrollBarYMin.Position:=-5;ScrollBarYMax.Position:=5;
     ScrollBarGroesse.Position:=30
    End;
  4:Begin
     LabelFormel.Caption:='z=f(x,y)=Sin(x*y)';
     ScrollBarXMin.Position:=-4;ScrollBarXMax.Position:=4;
     ScrollBarYMin.Position:=-4;ScrollBarYMax.Position:=4;
     ScrollBarGroesse.Position:=40
    End;
  5:Begin
     LabelFormel.Caption:='z=f(x,y)=1.5*(x-y)*Cos(x-y)/(x*x+y*y+0.25)';
     ScrollBarXMin.Position:=-3;ScrollBarXMax.Position:=3;
     ScrollBarYMin.Position:=-3;ScrollBarYMax.Position:=3;
     ScrollBarGroesse.Position:=60
    End;
  6:Begin
     LabelFormel.Caption:='z=f(x,y)=Cos(0.1*(x*x+y*y))';
     ScrollBarXMin.Position:=-12;ScrollBarXMax.Position:=12;
     ScrollBarYMin.Position:=-12;ScrollBarYMax.Position:=12;
     ScrollBarGroesse.Position:=15
    End;
  7:Begin
     LabelFormel.Caption:='z=f(x,y)=Sin(x-y)/(x*x+0.1)';
     ScrollBarXMin.Position:=-4;ScrollBarXMax.Position:=4;
     ScrollBarYMin.Position:=-4;ScrollBarYMax.Position:=4;
     ScrollBarGroesse.Position:=40
    End;
  8:Begin
     LabelFormel.Caption:='z=f(x,y)=Sin(x+Cos(y))';
     ScrollBarXMin.Position:=-7;ScrollBarXMax.Position:=7;
     ScrollBarYMin.Position:=-7;ScrollBarYMax.Position:=7;
     ScrollBarGroesse.Position:=25
    End;
  9:Begin
     LabelFormel.Caption:='z=f(x,y)=Sin(x+Sin(x*y))';
     ScrollBarXMin.Position:=-4;ScrollBarXMax.Position:=4;
     ScrollBarYMin.Position:=-4;ScrollBarYMax.Position:=4;
     ScrollBarGroesse.Position:=40
    End
 End;
 ButtonStartClick(Sender)
end;

procedure TFormCompiler.ScrollBarXMaxChange(Sender:TObject);
begin
 LabelXMax.Caption:='xMax: '+IntToStr(ScrollBarXMax.Position);
 ButtonStartClick(Sender)
end;

procedure TFormCompiler.ScrollBarXMinChange(Sender:TObject);
begin
 LabelXMin.Caption:='xMin: '+IntToStr(ScrollBarXMin.Position);
 ButtonStartClick(Sender)
end;

procedure TFormCompiler.ScrollBarYMaxChange(Sender:TObject);
begin
 LabelYMax.Caption:='yMax: '+IntToStr(ScrollBarYMax.Position);
 ButtonStartClick(Sender)
end;

procedure TFormCompiler.ScrollBarYMinChange(Sender:TObject);
begin
 LabelYMin.Caption:='yMin: '+IntToStr(ScrollBarYMin.Position);
 ButtonStartClick(Sender)
end;

end.
